import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class ArrListTest {
    @Test
    public void testGet() {
        ArrList L1 = new ArrList(6);
        L1.addLast("a");
        L1.addLast("b");
        L1.addLast("c");

        // L1: a, b, c
        assertEquals("b", L1.get(1));

        ArrList L2 = new ArrList(6);
        L2.addFirst("b");
        L2.addFirst("a");
        L2.addLast("c");
        // L2: a b c
        L2.get(1);
        assertEquals("b", L2.get(1));

        ArrList L3 = new ArrList(6);
        L3.addLast("c");
        L3.addFirst("b");
        L3.addFirst("a");
        // L3: a b c
        assertEquals("b", L3.get(1));
    }

    @Test
    public void testResize() {
        ArrList smallL = new ArrList(2);
        smallL.addLast("d");
        smallL.addLast("e");
        smallL.addLast("f");
        // smallL: d e f
        assertEquals(3, smallL.size());
        assertEquals("d", smallL.get(0));
        assertEquals("e", smallL.get(1));
        assertEquals("f", smallL.get(2));

        smallL.addFirst("c");
        smallL.addFirst("b");
        smallL.addLast("g");
        smallL.addFirst("a");
        // smallL: a b c d e f g
        assertEquals(7, smallL.size());
        assertEquals("a", smallL.get(0));
        assertEquals("b", smallL.get(1));
        assertEquals("c", smallL.get(2));
        assertEquals("d", smallL.get(3));
        assertEquals("e", smallL.get(4));
        assertEquals("f", smallL.get(5));
        assertEquals("g", smallL.get(6));
    }
}
